# Changelog

## 0.1.x
### 0.1.0: Core Features Added
- **Images are modified through all selected options without saving, reducing quality degradation and saving local storage.**
- **All core features are available:**
    - Simple TUI including options for selecting:
    - Resize
    - Change EXIF (with options from exif_options.yaml), copy original or leave empty
    - Convert to grayscale
    - Change contrast
    - Change brightness
    - Rename images (numbers are added automatically at the end)
    - Invert image order (so that the first image gets the last number and the last image gets the first; this is useful when the original numbering is reversed, which often happens when scanning 35mm film).
    - Add watermark (**Experimental**, requires the correct font to be installed)
- **Settings via YAML:**
    - At the start of the program, the user is asked to save default values, such as JPG quality, resize options, and more. This way, the settings don't have to be entered at every start. Upon starting, the user is prompted to confirm whether they want to keep the current settings from the settings file.
    - Options for changing EXIF data are saved in exif_options.yaml. Here, you can enter all the models, lenses, etc., you would like to select within the program.


## 0.0.x
### 0.0.3: Enhanced Functionality - now useable
- **New Image Modification Functions:**
    - Added support for Grayscale conversion.
    - Introduced Brightness adjustment.
   - Enhanced with Contrast adjustment.
- **New User Selection/Settings Features:**
    - Default values for settings can now be saved, such as:
    - JPEG quality.
    - PNG compression.
    - Additional optimization preferences.
    - Input folder, output folder, and file type are requested for every session.
- **Progress Bar for Image Processing:**
    - Implemented a progress bar to visually track the processing of images.

### 0.0.2: Enhanced Functionality
- **First Functional Features:**
    - Introduced the first operational functions, enabling the program to process images based on user input.
- **User Interaction:**
    - Added functionality to prompt users for their desired operations (e.g., resizing and/or changing EXIF data) and gather necessary inputs.
- **Image Processing Pipeline:**
    - The program now traverses a folder, opens images, applies modifications, and saves the processed files to the specified output location.
- **EXIF Handling:**
    - If EXIF changes are not desired, the program offers an option to copy the original EXIF data while adjusting key fields (e.g., image dimensions).
- **No Safety Checks Yet:**
    - Input validation (e.g., verifying folder existence, ensuring numeric input for percentages) is not yet implemented.
- **Foundation for Future Features:**
    - The groundwork allows for seamless addition of new image processing functions, leveraging the main class and TUI structure.

### Version 0.0.1: Initial Setup
- **Foundation Work:**
    - Established the groundwork for the project, focusing on testing and selecting the most effective tools. Transitioned from PyExifTool and Wand to Pillow and Piexif to minimize dependencies and streamline usability.
- **Proof of Concept:**
    - Conducted extensive testing and developed proof-of-concept functions to evaluate how various libraries integrate and perform.
- **TUI Development:**
    - Opted to use simple_term_menu instead of textual for the terminal-based user interface (TUI), leveraging prior experience to accelerate functional development over interface design.
- **AI Exploration:**
    - Tested local generative AI tools such as OpenCoder and Qwen2-Coder, exploring their potential for future project integration.
- **Project Status:**
    - The majority of work so far focuses on proof-of-concept implementation and experimentation.
